﻿; ----- PaintGraphic3SupportProgram -----
; Ver.1.0
; by Junya Renno 

;---------------- 初期設定 ------------------
SetWinDelay, 0
SetBatchLines, -1
CoordMode, Pixel, Screen
CoordMode, Mouse, Screen

IniRead, toolPar,pg3Support.ini,magnification,mag_rate,1

toolParNum := floor(toolPar*4-3)
toolBoxArray1 := [23,29,35,40,46]
toolBoxArray2 := [6,6,7,8,10]

myFunc := RegisterCallback("WinActivateHandler")

myHook := DllCall("SetWinEventHook"
, "UInt", 0x00000003 ; eventMin      : EVENT_SYSTEM_FOREGROUND
, "UInt", 0x00000003 ; eventMax      : 
, "UInt", 0          ; hModule       : self
, "UInt", myFunc     ; hWinEventProc : 
, "UInt", 0          ; idProcess     : All process
, "UInt", 0          ; idThread      : All threads
, "UInt", 0x0003     ; dwFlags       : WINEVENT_SKIPOWNTHREAD | WINEVENT_SKIPOWNPROCESS
, "UInt")

;-------------- ツールボックスから情報取り込み -------------------


Gosub,ToolBoxGet
pushFlag = 1


; -------------- タスクトレイのメニュー設定 -----------------
Menu, TRAY,Tip,pg3Support
Menu, TRAY,NoStandard
Menu, TRAY,Add,再読み込み,ReloadPg3Support
Menu, TRAY,Add,一時停止,SuspendPg3Support
Menu, TRAY,Add,終了,ExitPg3Support
Menu, TRAY,Icon,,,1

;-----------------  キーリマップ部分  -----------------------
#IfWinActive,ahk_class FPaintPro100MainWndClass

Space::Gosub,PanTool
Space up::Gosub,ToolBoxSet

;WheelDown::numpadSub
;WheelUp::numpadAdd

PrintScreen::Send,{PRINTSCREEN}^u{ESC}
!PrintScreen::Send,!{PRINTSCREEN}^u{ESC}

~RButton & WheelDown::MouseClick, WheelDown, , , 2
RButton & WheelUp::MouseClick, WheelUp, , , 2

^Right::WinScroll(1,-1)
^Up::WinScroll(-1,0)
^Left::WinScroll(0,-1)
^Down::WinScroll(-1,1)

+RButton::
	MouseGetPos, X, Y
	PixelGetColor, color, %X%, %Y% ,RGB
	r := SplitRgb_r(color)
	g := SplitRgb_g(color)
	b := SplitRgb_b(color)

	StringReplace,color,color,0x,#
	Clipboard = %color%	
	ClipWait, 1
	Tooltip, %color% : r=%r% g=%g% b=%b%
	Sleep, 1000

	Tooltip,
return

exit

;--------------- 以降サブルーチン -------------------------
SplitRgb_r(color){
	StringMid, r,color,3,2
	r = 0x%r%
	r+=0
	return %r%
}

SplitRgb_g(color){
	StringMid, g,color,5,2
	g = 0x%g%
	g+=0
	return %g%
}

SplitRgb_b(color){
	StringRight, b, color, 2
	b = 0x%b%
	b+=0
	return %b%
}


;--------------- パニングツール ---------------
PanTool:
	if pushFlag = 1
	{
		Gosub,ToolBoxGet
		Send,^!p
	}
return

;--------------- ツールボタンの色を記憶 ---------------
ToolBoxGet:
	if pushFlag = 1
	{
		WinGetPos, X, Y,,, PanelBaseFrame
		Loop,9
		{
			lc = %A_index%
			buttonX := (lc-1)*toolBoxArray1[toolParNum]+toolBoxArray2[toolParNum]
			buttonY := (66*toolPar)

			PixelGetColor, tools%A_index%, X+buttonX, y+buttonY
			pgColor := tools%A_index%
			
;			if tools%A_index% = 0xE9D495
			if tools%A_index% != 0xFFFFFF
			{
				buttonNum = %A_index%
				break
			}
		}
		pushFlag = 0
	}	
return


;------------------ ツールボタン操作 --------------------
ToolBoxSet:
	tb := buttonNum+5
	ControlClick,  button%tb%,  PanelBaseFrame,,LEFT,2
	pushFlag = 1
return

;---------------------------- 再読み込み ------------------------------------
ReloadPg3Support:
	Reload
return

;--------------------------- 一時停止 ---------------------------------------
SuspendPg3Support:
	Suspend
return

ExitPg3Support:
	ExitApp
return
;
; type
;  SB_HORZ=0, SB_VERT=1, SB_CTRL=2
;
GetScrollInfoAll(hwnd, type, ByRef nMin="", ByRef nMax="", ByRef nPage="", ByRef nPos="", ByRef nTrackPos="") {
		VarSetCapacity(SCROLLINFO, 7*4, 0x00)
		NumPut(28,   SCROLLINFO, 0, "Int")
		NumPut(0x17, SCROLLINFO, 4, "Int") ; SIF_RANGE & SIF_PAGE & SIF_POS & SIF_TRACKPOS = 0x17
		nMin:="", nMax:="", nPage:="", nPos:="", nTrackPos:=""
		if (!DllCall("user32.dll\GetScrollInfo", "UInt", hwnd, "Int",type, "Ptr", &SCROLLINFO, "Int"))
			Return false
		nMin      := NumGet(SCROLLINFO,  8, "Int")
		nMax      := NumGet(SCROLLINFO, 12, "Int")
		nPage     := NumGet(SCROLLINFO, 16, "Int")
		nPos      := NumGet(SCROLLINFO, 20, "Int")
		nTrackPos := NumGet(SCROLLINFO, 24, "Int")
		Return true
}


;スクロールのためにメッセージを投げる
WinScroll(x,y){
	ControlGet, ctrl,Hwnd,,,A
	if (x=0 || x=1)
	{
		PostMessage, 0x114,  x ,0,,ahk_id %ctrl%
		PostMessage, 0x114, 0x8,0,,ahk_id %ctrl%
	}
	if (y=0 || y=1)
	{
		PostMessage, 0x115,  y ,0,,ahk_id %ctrl%
		PostMessage, 0x115, 0x8,0,,ahk_id %ctrl%
	}
}

